## lib32-virtualgl-3.1.4-1.src.tar.gz

=== client/CMakeLists.txt ===
###############################################################################
# CLIENT
###############################################################################

include_directories(../common)

add_library(glframe STATIC GLFrame.cpp)
target_link_libraries(glframe ${OPENGL_gl_LIBRARY})

add_executable(vglclient vglclient.cpp ClientWin.cpp VGLTransReceiver.cpp)
target_link_libraries(vglclient vglcommon ${FBXLIB} glframe vglsocket)
install(TARGETS vglclient DESTINATION ${CMAKE_INSTALL_BINDIR})

configure_file(vglconnect.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/vglconnect
	@ONLY)
execute_process(COMMAND chmod +x vglconnect
	WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
install(PROGRAMS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/vglconnect
	DESTINATION ${CMAKE_INSTALL_BINDIR})

=== diags/CMakeLists.txt ===
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	add_executable(cpustat cpustat.c)
	install(TARGETS cpustat DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

add_executable(imgdiff imgdiff.c)
target_link_libraries(imgdiff vglutil)
if(UNIX)
	target_link_libraries(imgdiff m)
endif()

if(MINGW)
	add_definitions(-DWINVER=0x0600)
endif()
if(WIN32)
	add_executable(tcbench tcbench.cpp)
else()
	include_directories(${X11_XTest_INCLUDE_PATH})
	add_executable(tcbench tcbench.cpp dsimple.c)
	target_link_libraries(tcbench ${X11_XTest_LIB})
endif()
target_link_libraries(tcbench fbx)
install(TARGETS tcbench DESTINATION ${CMAKE_INSTALL_BINDIR})

=== util/CMakeLists.txt ===
add_library(vglutil STATIC GenericQ.cpp Log.cpp Mutex.cpp Thread.cpp bmp.c
	pf.c)
if(UNIX)
	target_link_libraries(vglutil pthread)
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
	target_link_libraries(vglutil rt)
endif()

add_executable(bmptest bmptest.c md5.c md5hl.c)
target_link_libraries(bmptest vglutil)

add_executable(pftest pftest.c)
target_link_libraries(pftest vglutil)

if(EXISTS /dev/urandom)
	message(STATUS "Using /dev/urandom for random number generation")
	add_definitions(-DHAVE_DEVURANDOM)
endif()

add_library(vglsocket STATIC Socket.cpp)
target_link_libraries(vglsocket vglutil)
if(WIN32)
	target_link_libraries(vglsocket ws2_32.lib)
endif()
if(CMAKE_SYSTEM_NAME MATCHES "SunOS")
	target_link_libraries(vglsocket socket xnet)
endif()

add_executable(nettest nettest.cpp)
target_link_libraries(nettest vglsocket)
if(CMAKE_SYSTEM_NAME MATCHES "SunOS")
	target_link_libraries(nettest kstat)
endif()
install(TARGETS nettest DESTINATION ${CMAKE_INSTALL_BINDIR})

add_library(fbx STATIC fbx.c)
target_link_libraries(fbx vglutil)

add_executable(fbxtest fbxtest.cpp)
target_link_libraries(fbxtest fbx)

if(UNIX)
	target_link_libraries(fbx ${X11_X11_LIB} ${X11_Xext_LIB})
endif()

if(VGL_USEXV)
	add_library(fbxv STATIC fbxv.c)
	target_link_libraries(fbxv ${X11_Xv_LIB} ${X11_X11_LIB} ${X11_Xext_LIB})

	add_executable(fbxvtest fbxvtest.c)
	target_link_libraries(fbxvtest fbxv)
endif()

add_executable(threadtest threadtest.cpp)
target_link_libraries(threadtest vglutil)

if(UNIX)
	option(VGL_USEIFR "Add nVidia Inband Frame Readback support to glreadtest"
		FALSE)
	if(VGL_USEIFR)
		message(STATUS "Enabling nVidia Inband Frame Readback support in glreadtest")
		set(DEFAULT_IFR_INCLUDE_DIR /opt/nvgrid/inc)
		set(IFR_INCLUDE_DIR ${DEFAULT_IFR_INCLUDE_DIR} CACHE PATH
			"Path to nVidia Inband Frame Readback include files (default: ${DEFAULT_IFR_INCLUDE_DIR})")
		add_definitions(-DUSEIFR)
		message(STATUS "IFR_INCLUDE_DIR = ${IFR_INCLUDE_DIR}")
		include_directories(${IFR_INCLUDE_DIR})
		include_directories(${IFR_INCLUDE_DIR}/../samples/common)
		set(IFRLIB nvidia-ifr)
	endif()

	add_executable(glreadtest glreadtest.cpp)
	target_link_libraries(glreadtest ${OPENGL_gl_LIBRARY} ${OPENGL_glu_LIBRARY}
		${X11_X11_LIB} ${IFRLIB} vglutil)
	if(VGL_BUILDSERVER)
		install(TARGETS glreadtest DESTINATION ${CMAKE_INSTALL_BINDIR})
	endif()
endif()

if(WIN32)
	configure_file(utiltest-win.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/utiltest)
else()
	configure_file(utiltest.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/utiltest)
	execute_process(COMMAND chmod +x ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/utiltest)
endif()

=== PKGBUILD ===
# Maintainer: Sven-Hendrik Haase <svenstaro@archlinux.org>
# Contributor: FigoDaPaura <ffigoDaPaura>

pkgname=lib32-virtualgl
pkgver=3.1.4
pkgrel=1
pkgdesc="32-bit serverside components for 64-bit VirtualGL servers"
arch=('x86_64')
url="https://virtualgl.org"
license=('LGPL')
depends=('virtualgl' 'lib32-libxv' 'lib32-glu' 'lib32-libjpeg-turbo' 'lib32-opencl-driver' 'lib32-ocl-icd')
makedepends=('lib32-libxv' 'lib32-glu' 'virtualgl' 'cmake' 'gcc-multilib' 'lib32-mesa' 'lib32-mesa-libgl' 'lib32-libxtst' 'opencl-headers' 'ninja')
source=("https://github.com/VirtualGL/virtualgl/releases/download/${pkgver}/VirtualGL-${pkgver}.tar.gz"{,.sig})
sha512sums=('266af1ddb923e07f52bba166cd6dd6066b371928946a0cd7cf5d200dde2b4bad6d3c7f1477dd6c575f830b42705468d444e413eedb4305ec34dfefab138d949f'
            'SKIP')
b2sums=('d651fd657befff706b846ff0e33801b659b50944fb9abc1b9cb8333fe1b897790e513a9156bea903d9337d093f78d6a74964be5711bdd4d1d43d76923dd96a7c'
        'SKIP')
validpgpkeys=('AE1A7BA4EFFF9A9987E1474C4BACCAB36E7FE9A1') # The VirtualGL Project (Signing key for official binaries) <information@VirtualGL.org>

prepare() {
  cd "VirtualGL-$pkgver"

  # FS#48403
  export LDFLAGS="${LDFLAGS/--as-needed,}"
}

build() {
  cd "VirtualGL-$pkgver"

  export CC="gcc -m32"
  export CXX="g++ -m32"
  export PKG_CONFIG_PATH="/usr/lib32/pkgconfig"

  cmake \
      -GNinja \
      -Bbuild \
      -DCMAKE_INSTALL_PREFIX=/usr \
      -DCMAKE_INSTALL_LIBDIR=/usr/lib32 \
      -DCMAKE_INSTALL_BINDIR=/usr/bin \
      -DCMAKE_BUILD_TYPE='None' \
      -DTJPEG_INCLUDE_DIR=/usr/include \
      -DTJPEG_LIBRARY=/usr/lib32/libturbojpeg.so \
      -DX11_X11_LIB=/usr/lib32/libX11.so \
      -DX11_Xext_LIB=/usr/lib32/libXext.so \
      -DOPENGL_gl_LIBRARY=/usr/lib32/libGL.so
  ninja -C build
}

package() {
  cd "VirtualGL-$pkgver"
  DESTDIR="$pkgdir" ninja install -C build

  cd "$pkgdir/usr"
  mv bin/glxspheres glxspheres32
  rm -rf bin
  mkdir -p bin
  mv glxspheres32 bin/

  rm -rf "$pkgdir/usr/share"
  rm -rf "$pkgdir/usr/include"
}
